"""
    Patches Folder.
"""
# $Id: WebImportPatch.py,v 1.3 2002/01/23 20:38:58 adrian Exp $
#
# $Log: WebImportPatch.py,v $
# Revision 1.3  2002/01/23 20:38:58  adrian
# Fixed minor bug that prevented the auto-generation of the object id
# from the downloaded URL
#
# Revision 1.2  2001/10/21 10:18:04  adrian
# no message
#
#
__version__ = '$Revision: 1.3 $'[11:-2]

import OFS.Folder
import urllib
import Globals
import OFS.Image
import string

def cookId(id, title, url):
    if not id and url:
        title=title or url
        id=url[max(string.rfind(url, '/'),
                    string.rfind(url, '\\'),
                    string.rfind(url, ':'),
                    )+1:]                  
    return id, title

def manage_performWebImport(self, url, id='', title='', submit=None, REQUEST=None):
    """ Attempts to perform a WebImport operation. """
    uo=urllib.URLopener()
    ds=uo.open(url)
    info=ds.info()
    data=ds.read()
    id, title=cookId(id, title, url)
    return OFS.Image.manage_addFile(self,
        id=id, title=title, file=data,
        content_type=info.getheader('content-type'),
        REQUEST=REQUEST)

targets = (
    OFS.Folder.Folder,
)
manage_options = (
    {'label':'Web Import', 'action':'manage_performWebImportForm',
     'help':('PatchKit', 'WebImport.stx'),
    },
)
methods = {
    'manage_performWebImportForm':
        Globals.DTMLFile('www/WebImport', globals()),
    'manage_performWebImport': manage_performWebImport,
}
