"""
    Zope Management Interface Style Sheet Patch
    ==== ========== ========= ===== ===== =====

    The patch adds a ZStyleSheet to the root of your Zope
    with its contents set to the contents of the standard
    manage_page_style.css and points the ZMI at it.

    It also adds two DTML Methods initially containing the
    default ZMI header and ZMI menu.

    Everything can then be modified using the ZMI.
"""
# $Id: ZMImanagePatch.py,v 1.1 2001/11/29 10:40:58 adrian Exp $
#
# $Log: ZMImanagePatch.py,v $
# Revision 1.1  2001/11/29 10:40:58  adrian
# Added support for top and side ZMI panels as objects in the ZODB.
# Changed name from ZSSmanagePatch to ZMImanagePatch.
#
# Revision 1.3  2001/10/29 09:37:49  adrian
# Cleaned up an "Ambiguous name..." warning in ZSS Manage Patch
#
# Revision 1.2  2001/10/21 10:18:56  adrian
# no message
#
#
__version__ = '$Revision: 1.1 $'[11:-2]

import App
import string
import Globals

def performPatch(app):
    """ Patch navigation to use the new manage_page_style.css """
    try:
        from Products.ZStyleSheet.ZStyleSheet import ZStyleSheet
        if hasattr(App.Management.Navigation, 'manage_page_style.css'):
            css = getattr(App.Management.Navigation, 'manage_page_style.css')
            setattr(App.Management.Navigation, 'manage_page_style_orig', css)
            delattr(App.Management.Navigation, 'manage_page_style.css')
            delattr(App.Management.Navigation, 'manage_page_style.css__roles__')
            css.setName('manage_page_style_orig')
        else:
            css = getattr(App.Management.Navigation, 'manage_page_style_orig')
        from OFS.DTMLMethod import DTMLMethod
        if hasattr(App.Management.Navigation, 'manage_top_frame'):
            mtf = getattr(App.Management.Navigation,'manage_top_frame')
            setattr(App.Management.Navigation, 'manage_top_frame_orig', mtf)
            delattr(App.Management.Navigation, 'manage_top_frame')
            delattr(App.Management.Navigation, 'manage_top_frame__roles__')
            mtf.setName('manage_page_style_orig')
        else:
            mtf = getattr(App.Management.Navigation, 'manage_top_frame')
        if hasattr(App.Management.Navigation, 'manage_menu'):
            mm = getattr(App.Management.Navigation,'manage_menu')
            setattr(App.Management.Navigation, 'manage_menu_orig', mtf)
            delattr(App.Management.Navigation, 'manage_menu')
            delattr(App.Management.Navigation, 'manage_menu__roles__')
            mm.setName('manage_menu_orig')
        else:
            mm = getattr(App.Management.Navigation, 'manage_menu')
        if not hasattr(app, 'manage_page_style.css'):
            zss = ZStyleSheet('manage_page_style.css', 'Zope Management Interface Style Sheet')
            app._setObject(zss.getId(), zss)
            zss.manage_importCSS(file = css(app, zmi_embedded_css=1))
            for item in zss._properties:
                if item['id'] == 'linkstyle':
                    zss.linkstyle = zss.linkStyleList[2]
                    item['mode'] = ''
        if not hasattr(app, 'manage_top_frame'):
            zmtf = DTMLMethod(mtf.read(), __name__='manage_top_frame')
            app._setObject(zmtf.getId(), zmtf)
        if not hasattr(app, 'manage_menu'):
            zmm = DTMLMethod(mm.read(), __name__='manage_menu')
            app._setObject(zmm.getId(), zmm)
        Globals.default__class_init__(App.Management.Navigation)
    except:
        pass
